package com.chinacreator.datasync.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.chinacreator.datasync.entity.SyncLog;

@Mapper
public interface FlagDealDao {
	
	/**
	 * 查询推入队列长时间没有处理的数据
	 * 
	 * @param size
	 * @return
	 */
	public List<SyncLog> pageQueryDealFail(@Param(value = "pagesize")int size);
	public List<SyncLog> pageQueryDealFail2(@Param(value = "pagesize")int size);
	
	/**
	 * 查询同步成功，但长时间没有更新订购关系表的记录
	 * 
	 * @param size
	 * @return
	 */
	public List<SyncLog> pageQueryDealSuccess(@Param(value = "pagesize")int size);
	
	
	/**
	 * 把历史数据插入历史表
	 * 
	 * @param dealtime
	 * @return
	 */
	public int insertHisData(@Param(value = "dealtime")String dealtime);
	
	/**
	 * 把历史数据从原表删除
	 * 
	 * @param dealtime
	 * @return
	 */
	public int deleteHisData(@Param(value = "dealtime")String dealtime);
	
	
	/**
	 * 更新订购关系记录同步失败
	 * 
	 * @param id
	 * @param userid
	 * @return
	 */
	public int updateOrderRelationFail(@Param(value = "id")String id,@Param(value = "userid")String userid);
	
	/**
	 * 更新订购关系记录同步成功
	 * 
	 * @param id
	 * @param userid
	 * @return
	 */
	public int updateOrderRelationSuccess(@Param(value = "id")String id,@Param(value = "userid")String userid,@Param(value = "status")String status);
	
	/**
	 * 更新同步标记已经处理
	 * 
	 * @param id
	 * @param userid
	 * @return
	 */
	public int updateSyncLog(@Param(value = "syncid")String syncid,@Param(value = "orderid")String orderid);
	
	public int updateSyncLogById(@Param(value = "id")String id);
	
	/**
	 * 查询同一次同步，有多少子同步还未成功
	 * 
	 * @param id
	 * @param userid
	 * @return
	 */
	public int countSyncLogFail(@Param(value = "syncid")String syncid,@Param(value = "orderid")String orderid);
	
	/**
	 * 查询同一次同步，有多少子同步还未处理
	 * 
	 * @param id
	 * @param userid
	 * @return
	 */
	public int countSyncLog(@Param(value = "syncid")String syncid,@Param(value = "orderid")String orderid);
	
	
	public String getCurrtime();
}
