package com.chinacreator.datasync.db;

import javax.sql.DataSource;

import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.autoconfigure.jdbc.DataSourceBuilder;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

//@Configuration
//@MapperScan(basePackages = "com.chinacreator.datasync.dao", sqlSessionTemplateRef  = "test1SqlSessionTemplate")
public class DataSource1Config {

    @Bean(name = "test1DataSource")
    @ConfigurationProperties(prefix = "spring.datasource.datasync")
    @Primary
    public DataSource testDataSource() {
        return DataSourceBuilder.create().build();
    }

    @Bean(name = "test1SqlSessionFactory")
    @Primary
    public SqlSessionFactory testSqlSessionFactory(@Qualifier("test1DataSource") DataSource dataSource) throws Exception {
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>data source 1 pool class>>>>>>>>>>>>>>>>>>>>");
    	System.out.println("dataSource name:  "+dataSource.getClass().getName());
    	System.out.println("initialSize:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getInitialSize());
    	System.out.println("minIdle:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getMinIdle());
    	System.out.println("maxIdle:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getMaxIdle());
    	System.out.println("maxActive:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getMaxActive());
    	System.out.println("testOnBorrow:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).isTestOnBorrow());
    	System.out.println("testOnReturn:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).isTestOnReturn());
    	System.out.println("testWhileIdle:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).isTestWhileIdle());
    	System.out.println("ValidationQuery:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getValidationQuery());
    	System.out.println("ValidationInterval:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getValidationInterval());
    	System.out.println("validationQueryTimeout:  "+((org.apache.tomcat.jdbc.pool.DataSource)  dataSource).getValidationQueryTimeout());
    	System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>data source 1 pool class>>>>>>>>>>>>>>>>>>>>");
        SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
        bean.setDataSource(dataSource);
        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/*.xml"));
        return bean.getObject();
    }

    @Bean(name = "test1TransactionManager")
    @Primary
    public DataSourceTransactionManager testTransactionManager(@Qualifier("test1DataSource") DataSource dataSource) {
        return new DataSourceTransactionManager(dataSource);
    }

    @Bean(name = "test1SqlSessionTemplate")
    @Primary
    public SqlSessionTemplate testSqlSessionTemplate(@Qualifier("test1SqlSessionFactory") SqlSessionFactory sqlSessionFactory) throws Exception {
        return new SqlSessionTemplate(sqlSessionFactory);
    }

}