package com.chinacreator.datasync.handler;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CountDownLatch;

import org.slf4j.Logger;

import com.chinacreator.datasync.dao.FlagDealDao;
import com.chinacreator.datasync.entity.SyncLog;


/**
 * 
 * 同步数据处理
 * 
 * @author maoya
 *
 */
public class SyncDealFail implements Runnable {
	
	private Logger logger ;
	
	FlagDealDao dao ;
	
	private SyncLog log;
	private int totalSize;
	private CountDownLatch threadSignal;
	
	public static Map<String,Object> map = new HashMap<String, Object>();
	
	public SyncDealFail(SyncLog log, int totalSize, CountDownLatch threadSignal,Logger logger, FlagDealDao dao) {
		this.logger = logger;
		
		this.dao = dao;
		
		this.log = log;
		this.totalSize = totalSize;
		this.threadSignal = threadSignal;
	}
	
	public void run() {
		boolean result = false;
		long start = System.currentTimeMillis();
		
		try {
			int count = dao.countSyncLog(this.log.getSyncid(), this.log.getOrderid());
			if(count>0) {
				int i= dao.updateOrderRelationFail(this.log.getOrderid(), this.log.getUserid());
				if(i>0) {
					result = true;
					dao.updateSyncLog(this.log.getSyncid(), this.log.getOrderid());
				}else{
					dao.updateSyncLogById(this.log.getId());
				}
			}
			
		} catch (Exception e) {
			logger.error("处理异常", e);
		} finally {
			if(result) {
				logger.info("[同步失败标记],"+this.log.getUserid()+"," + this.log.getCpid() + "," + this.log.getSpid() + "，花费时间：" + (System.currentTimeMillis() - start) + " ms");
			}
		}
		
		threadSignal.countDown();
	}
	
	


}
