package com.chinacreator.datasync.handler;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CountDownLatch;

import org.slf4j.Logger;

import com.chinacreator.datasync.dao.FlagDealDao;
import com.chinacreator.datasync.entity.SyncLog;


/**
 * 
 * 同步数据处理
 * 
 * @author maoya
 *
 */
public class SyncDealSuccess implements Runnable {
	
	private Logger logger ;
	
	FlagDealDao dao ;
	
	private SyncLog log;
	private int totalSize;
	private CountDownLatch threadSignal;
	private SimpleDateFormat f = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
	
	public static Map<String,Object> map = new HashMap<String, Object>();
	
	public SyncDealSuccess(SyncLog log, int totalSize, CountDownLatch threadSignal,Logger logger, FlagDealDao dao) {
		this.logger = logger;
		
		this.dao = dao;
		
		this.log = log;
		this.totalSize = totalSize;
		this.threadSignal = threadSignal;
	}
	
	public void run() {
		boolean result = false;
		long start = System.currentTimeMillis();
		
		try {
			logger.info(f.format(new Date())+"=>查询待同步表是否有未同步成功数据开始，userid:"+log.getUserid()+"，syncid: "+this.log.getSyncid()+"orderid: "+this.log.getOrderid());
			int count = dao.countSyncLogFail(this.log.getSyncid(), this.log.getOrderid());
			logger.info(f.format(new Date())+"=>查询待同步表是否有未同步成功数据结束，userid: "+log.getUserid()+"，syncid: "+this.log.getSyncid()+"orderid: "+this.log.getOrderid()+"，count: "+count);
			if(count<=0) {
				result = true;
				logger.info(f.format(new Date())+"=>更新订购关系表开始，userid: "+log.getUserid()+"，syncid: "+this.log.getSyncid()+"orderid: "+this.log.getOrderid());
				dao.updateOrderRelationSuccess(this.log.getOrderid(), this.log.getUserid(),this.log.getStatus());
				logger.info(f.format(new Date())+"=>更新待同步开始，userid: "+log.getUserid()+"，syncid: "+this.log.getSyncid()+"orderid: "+this.log.getOrderid());
				dao.updateSyncLog(this.log.getSyncid(), this.log.getOrderid());
				logger.info(f.format(new Date())+"=>同步成功更新两表结束，userid: "+log.getUserid()+"，syncid: "+this.log.getSyncid()+"orderid: "+this.log.getOrderid());
			}else {
				dao.updateSyncLogById(this.log.getId());
			}
			
		} catch (Exception e) {
			logger.error("处理异常", e);
		} finally {
			if(result) {
				logger.info("[同步成功标记],"+this.log.getUserid()+"," + this.log.getCpid() + "," + this.log.getSpid() + "，花费时间：" + (System.currentTimeMillis() - start) + " ms");
			}
		}
		
		threadSignal.countDown();
	}
	
	


}
