package com.chinacreator.datasync.job;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.chinacreator.datasync.services.SyncFlagService;
import com.chinacreator.datasync.util.SpringContextUtils;

/**
 * 
 * 线下批量数据同步
 * 
 * @author maoya
 *
 */
@Component
public class TaskSyncFlagJob {

	/**
	 * 处理长时间没有同步处理的数据
	 * 
	 * @throws Exception
	 */
	@Scheduled(fixedDelayString = "${config.job.dealFail.fixedDelay}")
	public void dealFail() throws Exception{
		SyncFlagService service = (SyncFlagService) SpringContextUtils.getBean(SyncFlagService.class);
		service.dealFail();
	}


	@Scheduled(fixedDelayString = "${config.job.dealFail2.fixedDelay}")
	public void dealFail2() throws Exception{
		SyncFlagService service = (SyncFlagService) SpringContextUtils.getBean(SyncFlagService.class);
		service.dealFail2();
	}
	
	
	/**
	 * 处理同步成功，但触发器没有生效
	 * 
	 * @throws Exception
	 */
	@Scheduled(fixedDelayString = "${config.job.dealSuccess.fixedDelay}")  
	public void dealSuccess() throws Exception{
		SyncFlagService service = (SyncFlagService) SpringContextUtils.getBean(SyncFlagService.class);
		service.dealSuccess();
	}
	
	/**
	 * 迁移历史数据到历史表
	 * 
	 * @throws Exception
	 */
	@Scheduled(fixedDelayString = "${config.job.moveHis.fixedDelay}")  
	public void moveHis() throws Exception{
		SyncFlagService service = (SyncFlagService) SpringContextUtils.getBean(SyncFlagService.class);
		service.moveHis();
	}
	

}
